package edu.toronto.cs.algorithms;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.BitSet;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import edu.toronto.cs.parsers.IrrelevanceProofParser;
import edu.toronto.cs.util.StopWatch;

public class Irrelevance {

	public static DefaultHandler handler;
	public static SAXParserFactory factory = SAXParserFactory.newInstance();
	
	public static BitSet checkIrrelevance(File proofFile, ArrayList<Integer> variables) throws IOException {
		StopWatch stopWatch = new StopWatch();
		
		try {
			handler = new IrrelevanceProofParser(variables);

			SAXParser saxParser = factory.newSAXParser();

			stopWatch.reset();
			saxParser.parse(proofFile, handler);
			stopWatch.pause();
			
			System.out.println("Generate Irrel results: " + stopWatch);

		} catch (SAXException ex) {
			System.err.println("SAXException " + ex.getMessage());
			System.exit(2);
		} catch (ParserConfigurationException ex) {
			System.err.println("ParserCopnfigurationException " + ex.getMessage());
			System.exit(2);
		} catch (IOException ex) {
			System.err.println("IOException " + ex.getMessage());
			System.exit(2);
		}

		return ((IrrelevanceProofParser)handler).getResults();

	}

}
