package edu.toronto.cs.info;

import java.util.BitSet;
import java.util.ArrayList;

public class Variable {

	private String name;

	private ArrayList<Integer> satVariables;

	private BitSet irrel;
	private BitSet localIrrel;
	private BitSet periph;

	public Variable(int nmbP_i){
		this.satVariables = new ArrayList<Integer>(nmbP_i);
		this.irrel = new BitSet(nmbP_i);
		this.localIrrel = new BitSet(nmbP_i);
		this.periph = new BitSet(nmbP_i);
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public ArrayList<Integer> getSatVariables() {
		return satVariables;
	}

	public void setSatVariables(ArrayList<Integer> satVariables) {
		this.satVariables = satVariables;
	}

	public BitSet getIrrel() {
		return irrel;
	}

	public void setIrrel(BitSet irrel) {
		this.irrel = irrel;
	}

	public BitSet getLocalIrrel() {
		return localIrrel;
	}

	public void setLocalIrrel(BitSet localIrrel) {
		this.localIrrel = localIrrel;
	}

	public BitSet getPeriph() {
		return periph;
	}

	public void setPeriph(BitSet periph) {
		this.periph = periph;
	}

	public boolean isIrrelevant(){
		return irrel.cardinality() == 0;
	}

	public boolean isLocalIrrelevant(){
		return localIrrel.cardinality() == 0;
	}

	public boolean isPeripheral(){
		return periph.cardinality() == 0;
	}

}
