package edu.toronto.cs.parsers;

import java.util.ArrayList;
import java.util.BitSet;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import edu.toronto.cs.util.Constants;

public class IrrelevanceProofParser extends DefaultHandler {

	private int index;
	private ArrayList<Integer> variables;
	private BitSet results;
	
	public IrrelevanceProofParser(ArrayList<Integer> variables){
		super();
		this.variables = variables;
		this.results = new BitSet(variables.size());
	}

	public void startElement(String namespaceURI, String sName, String qName, Attributes attrs) throws SAXException {
		String eName = sName;

		if ("".equals(eName))
			eName = qName;

		if (eName.equals(Constants.VARIABLE)) {
			
			index = Integer.parseInt(attrs.getValue("i"));
			
			int i = variables.indexOf(index);
			if (i > -1) {
				results.set(i);
			}
			
		}
	}

	public BitSet getResults() {
		return results;
	}

}

