package edu.toronto.cs.parsers;

import java.util.ArrayList;
import java.util.BitSet;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import edu.toronto.cs.util.Constants;

public class LocalIrrelevanceProofParser extends DefaultHandler {

	public static int index;
	public static int currentRootMP;
	
	private ArrayList<Integer> variables;
	private BitSet results;
	
	public LocalIrrelevanceProofParser(ArrayList<Integer> variables){
		super();
		this.variables = variables;
		
		// first half contains model labels, second half property labels
		this.results = new BitSet(2 * variables.size());
	}

	public void startElement(String namespaceURI, String sName, String qName, Attributes attrs) throws SAXException {
		String eName = sName;

		if ("".equals(eName))
			eName = qName;

		if (eName.equals(Constants.ROOT)) {
			currentRootMP = Integer.parseInt(attrs.getValue("o"));
		}
			
		if (eName.equals(Constants.VARIABLE)) {
			
			index = Integer.parseInt(attrs.getValue("i"));
			
			int i = variables.indexOf(index);
			if (i > -1) {
				switch (currentRootMP){
					case 1:
						results.set(i);
						break;
					case 2:
						results.set(i + variables.size());
						break;
					case 3:
						results.set(i);
						results.set(i + variables.size());
						break;
				}
			}
		}

	}

	public BitSet getResults() {
		return results;
	}
}
